\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(strictargs,1);
read("dragon-defines.gp");
read("contfrac-polroot.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}


\\-----------------------------------------------------------------------------
\\ continued fraction of r

contfrac(r)
\\ contfrac(sqrt2,,10)    \\ no contfrac() of quad

contfrac_polroot(cubic('x), 100, 1, 2)

contfrac_polroot(x^2-2, 100, 1, 2)
contfrac_polroot(x-9/29, 100, 0, 100)

print("cubic C");
\\ C = cbrt(28 + sqrt(29*27))
\\ C^3 = 28 + sqrt(29*27)
\\ C^3 - 28 = sqrt(29*27)
\\ (C^3 - 28)^2 - 29*27 = 0
cubic_C_poly = x^6 - 56*x^3 + 1;
polroots(cubic_C_poly)
\\ 0.2614067766932752346746156713 
\\ 3.825455531986310937574485629 
contfrac_polroot(cubic_C_poly, 100, 3,4)
