\\ Copyright 2016 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

fromdigits(v,base=10) = subst(Pol(v),'x,base);  \\ new in gp 2.8.x

z_mod_b(z) = (real(z) + imag(z)) % 2;

z_base_to_n(z,b) = {
  my(l=List([]));  \\ bits of n low to high
  while(z,
        my(bit=z_mod_b(z));
        listput(l,bit);
        my(new_z=(z-bit)/b);
        if(z==new_z,return(-1));  \\ no n for this z
        z=new_z);
  fromdigits(Vecrev(l),2);
}
MinusUnpoint(z) = z_base_to_n(z,I-1);
PlusUnpoint(z) = z_base_to_n(z,I+1);

matrix(5,11,y,x,y=3-y;x-=6; MinusUnpoint(x+y*I))
matrix(5,11,y,x,y=3-y;x-=6; PlusUnpoint(x+y*I))
