\\ Copyright 2016, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("pol-pfrac.gp");
read("pol-ascend.gp");
read("dragon-defines.gp");


\\ A268411

\\ 1={1,-1},          1
\\ 2={1,-1,0},        1
\\ 3={1,0,-1},        1
\\ 4={1,-1,0,0},      1
\\ 5={1,-1,1,-1},     0
\\ 6={1,0,-1,0},      1
\\ 7={1,0,0,-1},      1
\\ 8={1,-1,0,0,0},    1
\\ 9={1,-1,0,1,-1},   0
\\ 10={1,-1,1,-1,0},  0

\\ 1,1,1,1, 0,1,1,1,0,0

a(n) =
{
  if(n==0,return(0));
  if(n%2==0,return(a(n\2)));
  n\=2;
  if(n%2==1,a(n), 1-a(n));
}

vector(50,n,n--; a(n))
vector(50,n,n--; if(a(n),-1,1))
\\ vector(50,n,n--; n+=10; a(2*n+1))

A246960(n) = dir(n)%4;
A005811(n) = dir(n);
vector(#A246960_samples,n,n--; A246960(n)) == A246960_samples
vector(#A005811_samples,n,n--; A005811(n)) == A005811_samples
vector(1000,n,n--; a(n)) == vector(1000,n,n--; my(d=A246960(n)); d==1||d==2)

b(n) =
{
  if(n==0,return(0));
  if(n%4==1, 1-b(n\2), b(n\2));
}
vector(100,n,n--; a(n)) == vector(100,n,n--; b(n))
vector(100,n,n--; a(n)) == vector(100,n,n--; dir(n)%4==1 || dir(n)%4==2)

my(k=8); vector(2^(k-1),n,n--; A246960(2^k-1-n)) == vector(2^(k-1),n,n--; (A246960(n)+1)%4)
my(k=8); vector(2^(k-1),n,n--; dir(2^k-1-n)) == vector(2^(k-1),n,n--; dir(n)+1)

A038189(n) = if(n<1, 0, ((n/2^valuation(n, 2)-1)/2)%2);
\\A038189(n-1)
vector(32,n,n--; a(n))
vector(32,n,n--; a(63-n))
vector(32,n,n--; a(n) == a(63-n))
my(k=8); vector(2^(k-1),n,n--; a(2^k-1-n)==a(n)) == vector(2^(k-1),n,n--; n%2)


\\ A213064   2n & ~n
high_of_each_run1s(n) =
{
  my(v=concat(0,binary(n)));
  v=vector(#v-1,i, v[i]==0 && v[i+1]==1);
  from_binary_vector(v);
}
vector(32,n, high_of_each_run1s(n))

\\ A229763   (2n ^ n) & n
low_of_each_run1s(n) =
{
  my(v=binary(n));
  v=vector(#v,i, v[i]==1 && (i==#v || v[i+1]==0));
  from_binary_vector(v);
}
vector(32,n, low_of_each_run1s(n))


vector(20,n,n--; 2*a(n))
vector(20,n,n--; dir(2*n) % 4)

vector(1000,n,n--; 2*a(n)) == vector(1000,n,n--; dir(2*n) % 4)


vector(30,n,n+=2; if(dir(2*n)%4==0,1,-1))
vector(30,n,n+=2; dragon_point(2*n+1)-dragon_point(2*n))
