#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016, 2017, 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use Lingua::EN::Numbers;
use Math::PlanePath::DragonCurve 118; # v.118 for xyxy_to_n_either()
use Math::PlanePath::CCurve 118;

use FindBin;
use lib $FindBin::Bin;
use MyDragon ':all';
use MyPrintwrap ':all';


my $level = 4;
print "  % generated by tools/$FindBin::Script\n";

my $path = Math::PlanePath::DragonCurve->new;
my ($n_lo, $n_hi) = $path->level_to_n_range($level);

sub transform {
  my ($x,$y) = @_;
  $x = -$x;
  $y = -$y;
  return ($x,$y);
}

$Printwrap = 2;
foreach my $n ($n_lo .. $n_hi-1) {
  my ($x1,$y1) = transform($path->n_to_xy($n));
  my ($x2,$y2) = transform($path->n_to_xy($n+1));
  my $arrow = ($n%2==0 ? '->' : '<-');
  printwrap(" \\draw[$arrow] ($x1,$y1)--($x2,$y2);");
}
printwrap_newline();

print "  % end generated\n";
exit 0;
